Package org.zkoss.zul.impl

## Class PageRenderer

- java.lang.Object
- - org.zkoss.zul.impl.PageRenderer

- All Implemented Interfaces:
    `PageRenderer`

      public class PageRenderer
      extends java.lang.Object
      implements PageRenderer

  The page render for ZUL pages.
  Since:
    5.0.0
  Author:
    tomyeh

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `PageRenderer()` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `render​(Page page, java.io.Writer out)` | Renders the page.
    `protected void` | `renderComplete​(Execution exec, Page page, java.io.Writer out)` | Renders the page if `Page.isComplete()` is true.
    `protected void` | `renderDesktop​(Execution exec, Page page, java.io.Writer out)` | Renders the desktop and the page.
    `protected void` | `renderPage​(Execution exec, Page page, java.io.Writer out, boolean au)` | Renders the page if `Page.isComplete()` is false.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### PageRenderer

          public PageRenderer()

  - ### Method Detail

    - #### render

          public void render​(Page page,
                             java.io.Writer out)
                      throws java.io.IOException

      Description copied from interface: `PageRenderer`
      Renders the page.
      Specified by:
        `render` in interface `PageRenderer`
        `out` - the output writer to put the content to (never null).
      Throws:
        `java.io.IOException`

    - #### renderDesktop

          protected void renderDesktop​(Execution exec,
                                       Page page,
                                       java.io.Writer out)
                                throws java.io.IOException

      Renders the desktop and the page.
      Throws:
        `java.io.IOException`

    - #### renderPage

          protected void renderPage​(Execution exec,
                                    Page page,
                                    java.io.Writer out,
                                    boolean au)
                             throws java.io.IOException

      Renders the page if `Page.isComplete()` is false.
      Parameters:
        `au` - whether it is caused by an asynchronous update
      Throws:
        `java.io.IOException`

    - #### renderComplete

          protected void renderComplete​(Execution exec,
                                        Page page,
                                        java.io.Writer out)
                                 throws java.io.IOException

      Renders the page if `Page.isComplete()` is true. In other words, the page content contains HTML/BODY tags.
      Throws:
        `java.io.IOException`